﻿using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using Verse;

namespace Outland
{
    public class StatPart_ArcaneEnergyMax : StatPart
    {
        public override void TransformValue(StatRequest req, ref float val)
        {
            Pawn pawn = req.Thing as Pawn;
            if (pawn != null)
            {
                Hediff_ArcaneAbilities hediff = (Hediff_ArcaneAbilities)pawn.health.hediffSet.GetFirstHediffOfDef(OutlandDefOf.Outland_ArcaneClass);
                if (hediff != null)
                {
                    val = OutlandMod.settings.arcane_capacityBase + (hediff.level * OutlandMod.settings.arcane_capacityPerLevel);
                }
            }
        }
        public override string ExplanationPart(StatRequest req)
        {
            Pawn pawn = req.Pawn;
            if (pawn != null)
            {
                Hediff_ArcaneAbilities hediff = (Hediff_ArcaneAbilities)pawn.health.hediffSet.GetFirstHediffOfDef(OutlandDefOf.Outland_ArcaneClass);
                if (hediff != null)
                {
                    StringBuilder report = new StringBuilder();
                    report.Append("Outland.ArcaneMaxBase_StatReport".Translate() + ": " + OutlandMod.settings.arcane_capacityBase);
                    report.Append("\n" + "Outland.ArcaneMaxLevel_StatReport".Translate() + ": +" + (hediff.level * OutlandMod.settings.arcane_capacityPerLevel));
                    return report.ToString();
                }
            }
            return null;
        }
    }
}
