﻿using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using Verse;

using HarmonyLib;

namespace Outland
{
    [HarmonyPatch(typeof(ResurrectionUtility), "Resurrect")]
    public static class Patch_ResurrectionUtility_Resurrect
    {
        public static void Postfix(Pawn pawn)
        {
            if (pawn.health.hediffSet.HasHediff(OutlandDefOf.Outland_SoulTrapped))
            {
                Hediff_SoulTrap hediff = (Hediff_SoulTrap)pawn.health.hediffSet.GetFirstHediffOfDef(OutlandDefOf.Outland_SoulTrapped);
                if (hediff.soulReaped && !pawn.health.hediffSet.HasHediff(OutlandDefOf.Outland_SoullessRage))
                {
                    Hediff rageHediff = HediffMaker.MakeHediff(OutlandDefOf.Outland_SoullessRage, pawn);
                    pawn.health.AddHediff(rageHediff);
                    pawn.health.RemoveHediff(hediff);
                }
            }
        }
    }
}
