﻿using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using Verse;

namespace Outland
{
    public static class Util_Classes
    {
        public static bool? anyArcaneClasses;
        public static bool? anyAlchemicalClasses;
        public static bool? anyMartialClasses;

        public static bool AnyArcaneClasses
        {
            get
            {
                if(anyArcaneClasses == null)
                {
                    if (DefDatabase<ClassDef>.AllDefs.EnumerableNullOrEmpty())
                    {
                        anyArcaneClasses = false;
                    }
                    else
                    {
                        anyArcaneClasses = DefDatabase<ClassDef>.AllDefs.Any(cd => cd.classType == ClassType.Arcane);
                    }
                }
                return (bool)anyArcaneClasses;
            }
        }

        public static bool AnyAlchemicalClasses
        {
            get
            {
                if (anyAlchemicalClasses == null)
                {
                    if (DefDatabase<ClassDef>.AllDefs.EnumerableNullOrEmpty())
                    {
                        anyAlchemicalClasses = false;
                    }
                    else
                    {
                        anyAlchemicalClasses = DefDatabase<ClassDef>.AllDefs.Any(cd => cd.classType == ClassType.Alchemical);
                    }
                }
                return (bool)anyAlchemicalClasses;
            }
        }

        public static bool AnyMartialClasses
        {
            get
            {
                if (anyMartialClasses == null)
                {
                    if (DefDatabase<ClassDef>.AllDefs.EnumerableNullOrEmpty())
                    {
                        anyMartialClasses = false;
                    }
                    else
                    {
                        anyMartialClasses = DefDatabase<ClassDef>.AllDefs.Any(cd => cd.classType == ClassType.Martial);
                    }
                }
                return (bool)anyMartialClasses;
            }
        }
    }
}
